#!/bin/sh
# iNative
# Умнее, чем вы думаете...
# Оперделим рабочую директорию:
mypath=${0%/*}
# Подгрузим необходимые библиотеки из рабочей папки:
LD_LIBRARY_PATH=$mypath
# берем опцию... (-w,-g,-u,)
com="$1"
# тырим операцию... (connect,disconnect)
command="$2"
# Опишем общую функцию проверки интернета:
inet_check()
{
# Запустим утилиту ping:
busybox ping -c 1 google.com
# Заберем вывод итога работы в некоторую переменную a:
a="$?"
}
# Функция отключения раздачи интернета нативу (общая):
disconnect()
{
# delete route default gw
route delete default
}

# Начало описания функций для wifi <>
# Функция раздачи интернета нативу с wi-fi (eth0):
connect_eth0()
{
# add default gw для Wi-Fi
route add default gw `cat /ezxlocal/dhcpc/dhcpcd-eth0.info | grep GATEWAY | sed s/GATEWAY=//g`
}
# Проверим, поднят ли wi-fi и подключимся к одной из сетей (eth0)
check_eth0()
{
# Смотрим наличие eth0 и результат складываем в переменную c:
c="`route | grep "eth0"`"
# Оценим переменную c:
if [ "$c" = "" ]
then
	# переменная пуста, eth0 не найден, пробуем выполнить быстрое подключение:
	(/usr/SYSqtapp/wlan/wlanapp -quickconnect)&
	sleep 7
	# Повторно проверим состояние запущенности подключения wi-fi:
	c="`route | grep "eth0"`"
	# Оценим переменную c:
	if [ "$c" = "" ]
	then
		# переменная пуста, eth0 не найден, пробуем выполнить обычное подключение:		
		/usr/SYSqtapp/wlan/wlanapp
		# Повторно проверим состояние запущенности подключения wi-fi:
		c="`route | grep "eth0"`"
		# Оценим переменную c:
		if [ "$c" = "" ]
		then
			# Выходим с ошибкой:
			exit 1
		fi
	fi
else
	# Мы нашли активное подключение к сети wi-fi
	# Посмотрим, есть ли шлюз по дефолту
	d="`route | grep "default"`"
	# Оценим переменную d:
	if [ "$d" != "" ]
	then
		# Удача, там что-то есть, прочекаем интернету:
		inet_check
		# Оценим переменную a:
		if [ "$a" = "0" ]
		then
			# Ура, она нулевая, все работает как нам надо, просто валим из проги, ничего более не делая:
			exit
		else	
			# Иначе, твою налево, ничего не работало, отключим этого овоща от интернета:		
			disconnect
		fi
	fi
fi
}
# Конец описания функций для wi-fi </>

# Функция подключения к USB(n,w):
connect_usb()
{
# add default gw для bluetooth
c="`route | grep "usbl0"`"
# Оценим переменную c:
if [ "$c" = "" ]
then
	# переменная пуста, eth0 не найден, говорим этому олуху, что он дурак :-):
	e="1"
else
	ifconfig usbl0 192.168.16.2 broadcast 192.168.16.7 netmask 255.255.255.248
	route add default gw 192.168.16.1
fi
}

# Функция раздачи интернета нативу с gprs:
connect_gprs()
{
if find $mypath/profil.conf
then
	# Заберем профиль:
	profil=`cat "$mypath"/profil.conf`
else
	# Сформируем меню со списком профилей:
	showRadio "iNative" "Select profil:" `$mypath/netexec4sh | sed -n '15,80 p' | sed 's/^.\{3\}//' | sed 's/ /_/'`
	# Заберем профиль:
	profil=$?
	if [ "$profil" = "0" ]
	then
		# Вы не выбрали профиль, выходим без продолжения!
		exit 1
	else
		# Профиль выбран и записан по умолчанию...
		echo "$profil" > $mypath/profil.conf
	fi
fi
# Подключимся:
($mypath/netexec4sh -n "$profil")&
}

# Опишем Gui Всей утилиты:
gui()
{
# Проверим интернет:
inet_check
# Оценим переменную a:
if [ "$a" = "0" ]
then
	# Ура, она нулевая, все работает как нам надо, просто валим из проги, ничего более не делая:
	i="ON"
else	
	# Иначе, твою налево, ничего не работало, отключим этого овоща от интернета:		
	i="OFF"
fi
# Запустим формирование меню:
showRadio "iNative" "Connect status: $i" "Connect to Wi-Fi" "Connect to GPRS" "Connect to USB"
RADIORES=$?
case "$RADIORES" in
"0")
exit
;;
"1")
if [ "$a" = "0" ]
then
	# Ура, она нулевая, все работает как нам надо, отключаем раздачу интернета нативу и выходим:
	disconnect
	# Проверим интернет:
	inet_check
	# Оценим переменную a:
	if [ "$a" = "1" ]
	then
		# Ура, она не нулевая, все работает как нам надо, сообщаем об успехе и валим из проги:		
		showNotify "iNative" "Disconnected!" 0 4
		exit
	else
		# Иначе, твою налево, ничего не с работало, error ахтунг, аааа, вываливаем ведро ошибок:
		showNotify "iNative" "Connected!" 1 4
		exit 1
	fi
	exit
else	
	# Проверим включенность wi-fi:
	check_eth0	
	# Иначе, интернет не роздан, ничего не работает, но мы за тем и притопали, чтобы включить сие говно:		
	connect_eth0
	# Проверим интернет:
	inet_check
	# Оценим переменную a:
	if [ "$a" = "0" ]
	then
		# Ура, она нулевая, все работает как нам надо, сообщаем об успехе и валим из проги:
		showNotify "iNative" "Connected!" 0 4
		exit
	else
		# Иначе, твою налево, ничего не с работало, error ахтунг, аааа, вываливаем ведро ошибок:
		showNotify "iNative" "Connect error!" 2 4
		exit 1
	fi
fi
;;
"2")
# Запросим поиск профиля по умолчанию...
if find $mypath/profil.conf
then
	# Нашли,удалим или нет?
	showQ "iNative" "Delete default profile gprs?" 1
	vivod="$?"
	if [ "$vivod" = "1" ]
	then
		rm -f $mypath/profil.conf
	fi
fi
connect_gprs
;;
"3")
if [ "$e" = "1" ]
then
	showNotify "iNative" "Connect error!" 2 4
else
	if [ "$a" = "0" ]
	then
		# Ура, она нулевая, все работает как нам надо, отключаем раздачу интернета нативу и выходим:
		disconnect
		# Проверим интернет:
		inet_check
		# Оценим переменную a:
		if [ "$a" = "1" ]
		then
			# Ура, она не нулевая, все работает как нам надо, сообщаем об успехе и валим из проги:		
			showNotify "iNative" "Disconnected!" 0 4
			exit
		else
			# Иначе, твою налево, ничего не с работало, error ахтунг, аааа, вываливаем ведро ошибок:
			showNotify "iNative" "Connected!" 1 4
			exit 1
		fi
		exit
	else		
		# Иначе, интернет не роздан, ничего не работает, но мы за тем и притопали, чтобы включить сие говно:		
		connect_usb
		# Проверим интернет:
		inet_check
		# Оценим переменную a:
		if [ "$a" = "0" ]
		then
			# Ура, она нулевая, все работает как нам надо, сообщаем об успехе и валим из проги:
			showNotify "iNative" "Connected!" 0 4
			exit
		else
			# Иначе, твою налево, ничего не с работало, error ахтунг, аааа, вываливаем ведро ошибок:
			showNotify "iNative" "Connect error!" 2 4
			exit 1
		fi
	fi
fi
;;
esac
}

start()
{
if [ "$com" = "-h" ]
then
echo 'iNative: connect to wi-fi, usb, gprs. Internet for native software...
Use: iNative [arg] [command]
Args:
-w wi-fi
-g gprs
-u usb
Commands:
connect
disconnect
-----------
iNative in applets:
iNative -w connect
vivod="$?"
0 - ok
1 - error'
else
	if [ "$com" = "" ]
	then
		gui
	else
		if [ "$com" = "-w" ]
		then
			if [ "$command" = "connect" ]
			then
				check_eth0
				connect_eth0
				inet_check
				exit $a
			else
				if [ "$command" = "disconnect" ]
				then
					disconnect
					inet_check
					if [ "$a" = "1" ]
					then					
						exit
					else
						exit 1
					fi
				fi
			fi
		else
			if [ "$com" = "-g" ]
			then
				if [ "$command" = "connect" ]
				then
					connect_gprs
					sleep 1
				else
					if [ "$command" = "disconnect" ]
					then
						disconnect
						inet_check
						if [ "$a" = "1" ]
						then					
							exit
						else
							exit 1
						fi
					fi
				fi
			else
				if [ "$com" = "-u" ]
				then
					if [ "$e" = "1" ]
					then
						exit 1
					else
						if [ "$command" = "connect" ]
						then
							connect_usb			
							inet_check
							exit $a
						else
							if [ "$command" = "disconnect" ]
							then
								disconnect
								inet_check
								if [ "$a" = "1" ]
								then					
									exit
								else
									exit 1
								fi
							fi
						fi
					fi
				fi
			fi
		fi
	fi
fi
}
# Ищем resolv.conf на своем месте...
if find /etc/resolv.conf
then
	# Нашли, читаем...
	resolv=`cat /etc/resolv.conf`
	# Смотрим, что прочиталось...
	if [ "$resolv" != "nameserver 8.8.8.8" ]
	then
		# Содержимое не допустимо! Перепишем его на свое...
		echo "nameserver 8.8.8.8" > /ezxlocal/resolv.conf
		# Перемонтируем...
		mount -o bind /ezxlocal/resolv.conf /etc/resolv.conf
	fi
else
	# Мы его вообще не нашли... Едрить его колотить... Посылаем всех далеким лесом...
	showNotify "iNative" "AAA NO,NO!" 2 4
	exit 1
fi
# Смотрим наличие папки iNative...
if find /ezxlocal/iNative -type d
then
	# Нашли, запускаем систему...
	start
else
	# Не нашли, линкуем...
	ln -s "$mypath" /ezxlocal/
	# Стартуем...
	start
fi